## mailio 0.23.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.16.3)

project(mailio VERSION 0.23.0)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(NOT DEFINED LIB_SUFFIX)
  set(LIB_SUFFIX "" CACHE STRING "Suffix for installed library path. Ex. 64 for lib64")
endif(NOT DEFINED LIB_SUFFIX)

# Set bindir, if not use -DBIN_INSTALL_DIR
if(NOT BIN_INSTALL_DIR)
  if(CMAKE_INSTALL_BINDIR)
    set(BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
  else(CMAKE_INSTALL_BINDIR)
    set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
  endif(CMAKE_INSTALL_BINDIR)
endif(NOT BIN_INSTALL_DIR)

# Set libdir, if not use -DLIB_INSTALL_DIR
if(NOT LIB_INSTALL_DIR)
  if(CMAKE_INSTALL_LIBDIR)
    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
  else(CMAKE_INSTALL_LIBDIR)
    set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
  endif(CMAKE_INSTALL_LIBDIR)
endif(NOT LIB_INSTALL_DIR)

# Set includedir, if not use -DINCLUDE_INSTALL_DIR
if(NOT INCLUDE_INSTALL_DIR)
  if(CMAKE_INSTALL_INCLUDEDIR)
    set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})
  else(CMAKE_INSTALL_INCLUDEDIR)
    set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include")
  endif(CMAKE_INSTALL_INCLUDEDIR)
endif(NOT INCLUDE_INSTALL_DIR)

# Set sharedir, if not use -DSHARE_INSTALL_DIR
if(NOT SHARE_INSTALL_DIR)
  if(CMAKE_INSTALL_DATADIR)
    set(SHARE_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}")
  else(CMAKE_INSTALL_DATADIR)
    set(SHARE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share")
  endif(CMAKE_INSTALL_DATADIR)
endif(NOT SHARE_INSTALL_DIR)

# options for mailio to control how the project is built.
option(MAILIO_BUILD_DOCUMENTATION "Turn on to build doxygen based documentation." ON)
option(MAILIO_BUILD_EXAMPLES "Turn on to build examples." ON)
option(MAILIO_BUILD_SHARED_LIBRARY "Turn on to build the shared library." ON)
option(MAILIO_BUILD_TESTS "Turn on to build the tests." ON)
option(MAILIO_DYN_LINK_TESTS "Turn on to dynamically link the tests." OFF)

# add a dependent option to build latex documentation or not.
include(CMakeDependentOption)
cmake_dependent_option(MAILIO_BUILD_LATEX_DOCUMENTATION "Build latex docs" ON "MAILIO_BUILD_DOCUMENTATION" ON)

if(WIN32)
    set(Boost_USE_STATIC_LIBS ON)
endif(WIN32)

find_package(Boost REQUIRED COMPONENTS system date_time regex unit_test_framework)
find_package(OpenSSL)
set(CMAKE_THREAD_PREFER_PTHREAD)
# "Use of both the imported target as well as this switch is highly recommended for new code."
set(THREADS_PREFER_PTHREAD_FLAG)
find_package(Threads)

set(project_sources
    ${PROJECT_SOURCE_DIR}/src/base64.cpp
    ${PROJECT_SOURCE_DIR}/src/binary.cpp
    ${PROJECT_SOURCE_DIR}/src/bit7.cpp
    ${PROJECT_SOURCE_DIR}/src/bit8.cpp
    ${PROJECT_SOURCE_DIR}/src/codec.cpp
    ${PROJECT_SOURCE_DIR}/src/dialog.cpp
    ${PROJECT_SOURCE_DIR}/src/imap.cpp
    ${PROJECT_SOURCE_DIR}/src/mailboxes.cpp
    ${PROJECT_SOURCE_DIR}/src/message.cpp
    ${PROJECT_SOURCE_DIR}/src/mime.cpp
    ${PROJECT_SOURCE_DIR}/src/pop3.cpp
    ${PROJECT_SOURCE_DIR}/src/quoted_printable.cpp
    ${PROJECT_SOURCE_DIR}/src/q_codec.cpp
    ${PROJECT_SOURCE_DIR}/src/smtp.cpp
)

set(project_headers
    ${PROJECT_SOURCE_DIR}/include/mailio/base64.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/binary.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/bit7.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/bit8.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/codec.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/dialog.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/imap.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/mailboxes.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/message.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/mime.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/pop3.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/quoted_printable.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/q_codec.hpp
    ${PROJECT_SOURCE_DIR}/include/mailio/smtp.hpp
)

# handle documentation
if(${MAILIO_BUILD_DOCUMENTATION})
    find_package(Doxygen COMPONENTS doxygen OPTIONAL_COMPONENTS dot)
    if(DOXYGEN_FOUND)
        set(DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/mailio)
        set(DOXYGEN_GENERATE_LATEX ${MAILIO_BUILD_LATEX_DOCUMENTATION})
        set(DOXYGEN_OUTPUT_PATH ${DOCOUTDIR})

        doxygen_add_docs(docs ${PROJECT_SOURCE_DIR}/include ALL WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

        # install the documentation
        install(DIRECTORY ${DOXYGEN_OUTPUT_DIRECTORY} DESTINATION docs)
    else(DOXYGEN_FOUND)
        message(STATUS "doxygen was not found, documentation will not be built")
    endif(DOXYGEN_FOUND)
endif(${MAILIO_BUILD_DOCUMENTATION})

set(LIBRARY_TYPE, "")
if (MAILIO_BUILD_SHARED_LIBRARY)
    set(LIBRARY_TYPE "SHARED")
else()
    set(LIBRARY_TYPE "STATIC")
endif()
add_library(${PROJECT_NAME} ${LIBRARY_TYPE} ${project_sources} ${project_headers})


# pkg-config support
set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}" )

if(IS_ABSOLUTE "${LIB_INSTALL_DIR}")
  set(libdir "${LIB_INSTALL_DIR}")
else(IS_ABSOLUTE "${LIB_INSTALL_DIR}")
  set(libdir "\${exec_prefix}/${LIB_INSTALL_DIR}")
endif(IS_ABSOLUTE "${LIB_INSTALL_DIR}")

if(IS_ABSOLUTE "${INCLUDE_INSTALL_DIR}")
  set(includedir "${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}")
else(IS_ABSOLUTE "${INCLUDE_INSTALL_DIR}")
  set(includedir "\${prefix}/${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}")
endif(IS_ABSOLUTE "${INCLUDE_INSTALL_DIR}")

configure_file(mailio.pc.in ${CMAKE_BINARY_DIR}/mailio.pc IMMEDIATE @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/mailio.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

configure_file(${PROJECT_SOURCE_DIR}/include/version.hpp.in version.hpp)
install(FILES ${CMAKE_BINARY_DIR}/version.hpp DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME})

# generate the export header for exporting symbols
# this is needed to generate a shared library.
include(GenerateExportHeader)
generate_export_header(${PROJECT_NAME} EXPORT_FILE_NAME export.hpp)
target_include_directories(${PROJECT_NAME}
    PUBLIC
        "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include;${CMAKE_CURRENT_BINARY_DIR}>"
        "$<INSTALL_INTERFACE:include>"
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/export.hpp DESTINATION "${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}")

if(Boost_FOUND)
    target_include_directories(${PROJECT_NAME} PUBLIC ${Boost_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES})
endif()

if(OPENSSL_FOUND)
    target_include_directories(${PROJECT_NAME} PUBLIC ${OPENSSL_INCLUDE_DIR})
    target_link_libraries(${PROJECT_NAME} ${OPENSSL_LIBRARIES})
endif()

if(MINGW)
    target_link_libraries(${PROJECT_NAME} -lws2_32 )
endif(MINGW)

if (MSVC)
    target_compile_options(${PROJECT_NAME} PRIVATE /W2 /WX)
else()
    target_compile_options(${PROJECT_NAME} PRIVATE -Wall -Wextra -Wpedantic)
endif()

install(DIRECTORY include/mailio DESTINATION ${INCLUDE_INSTALL_DIR})

install(TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}Config
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

export(TARGETS ${PROJECT_NAME} FILE ${PROJECT_NAME}Config.cmake)

install(EXPORT ${PROJECT_NAME}Config DESTINATION share/${PROJECT_NAME}/cmake)

# optionally build examples
if(${MAILIO_BUILD_EXAMPLES})
    add_subdirectory(examples)
    file(GLOB PNGS "${PROJECT_SOURCE_DIR}/examples/*.png")
    install(FILES ${PNGS} DESTINATION "${SHARE_INSTALL_DIR}/${PROJECT_NAME}/examples/")
endif(${MAILIO_BUILD_EXAMPLES})

if(${MAILIO_BUILD_TESTS})
    add_subdirectory(test)
    file(GLOB PNGS "${PROJECT_SOURCE_DIR}/test/aleph0.png")
    install(FILES ${PNGS} DESTINATION "${SHARE_INSTALL_DIR}/${PROJECT_NAME}/test/")
    file(GLOB TXTS "${PROJECT_SOURCE_DIR}/test/cv.txt")
    install(FILES ${TXTS} DESTINATION "${SHARE_INSTALL_DIR}/${PROJECT_NAME}/test/")
endif(${MAILIO_BUILD_TESTS})

=== test/CMakeLists.txt ===

function(add_mailio_tests SOURCE_FILE)
    get_filename_component(file_name ${SOURCE_FILE} NAME_WE)
    add_executable(${file_name} ${SOURCE_FILE})
    if (${MAILIO_DYN_LINK_TESTS})
	    add_definitions(-DBOOST_TEST_DYN_LINK)
    endif()
    target_link_directories(${file_name} PUBLIC ${Boost_LIBRARY_DIRS})
    target_link_libraries(${file_name} PUBLIC ${Boost_LIBRARIES} mailio ${CMAKE_THREAD_LIBS_INIT})
    install(TARGETS ${file_name} DESTINATION "${SHARE_INSTALL_DIR}/${PROJECT_NAME}/test")
endfunction(add_mailio_tests)

file(GLOB test_files ${CMAKE_CURRENT_SOURCE_DIR}/test*.cpp)
foreach(file_name ${test_files})
    add_mailio_tests(${file_name})
endforeach(file_name ${test_files})

=== debian/changelog ===
mailio (0.23.0-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 16 Apr 2024 23:44:04 +0200

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DMAILIO_BUILD_SHARED_LIBRARY=ON

## mailio 0.23.0+git20241012.8821f91

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,9 @@
 cmake_minimum_required (VERSION 3.16.3)
 
-project(mailio VERSION 0.23.0)
+project(mailio VERSION 0.24.0)
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 if(NOT DEFINED LIB_SUFFIX)
   set(LIB_SUFFIX "" CACHE STRING "Suffix for installed library path. Ex. 64 for lib64")
@@ -47,9 +48,10 @@
 # options for mailio to control how the project is built.
 option(MAILIO_BUILD_DOCUMENTATION "Turn on to build doxygen based documentation." ON)
 option(MAILIO_BUILD_EXAMPLES "Turn on to build examples." ON)
-option(MAILIO_BUILD_SHARED_LIBRARY "Turn on to build the shared library." ON)
 option(MAILIO_BUILD_TESTS "Turn on to build the tests." ON)
 option(MAILIO_DYN_LINK_TESTS "Turn on to dynamically link the tests." OFF)
+
+option(BUILD_SHARED_LIBS "Turn on to build mailio as a shared library. When off mailio is build as a static library." ON)
 
 # add a dependent option to build latex documentation or not.
 include(CMakeDependentOption)
@@ -59,7 +61,7 @@
     set(Boost_USE_STATIC_LIBS ON)
 endif(WIN32)
 
-find_package(Boost REQUIRED COMPONENTS system date_time regex unit_test_framework)
+find_package(Boost REQUIRED COMPONENTS system date_time regex)
 find_package(OpenSSL)
 set(CMAKE_THREAD_PREFER_PTHREAD)
 # "Use of both the imported target as well as this switch is highly recommended for new code."
@@ -77,6 +79,7 @@
     ${PROJECT_SOURCE_DIR}/src/mailboxes.cpp
     ${PROJECT_SOURCE_DIR}/src/message.cpp
     ${PROJECT_SOURCE_DIR}/src/mime.cpp
+    ${PROJECT_SOURCE_DIR}/src/percent.cpp
     ${PROJECT_SOURCE_DIR}/src/pop3.cpp
     ${PROJECT_SOURCE_DIR}/src/quoted_printable.cpp
     ${PROJECT_SOURCE_DIR}/src/q_codec.cpp
@@ -94,6 +97,7 @@
     ${PROJECT_SOURCE_DIR}/include/mailio/mailboxes.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/message.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/mime.hpp
+    ${PROJECT_SOURCE_DIR}/include/mailio/percent.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/pop3.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/quoted_printable.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/q_codec.hpp
@@ -117,13 +121,7 @@
     endif(DOXYGEN_FOUND)
 endif(${MAILIO_BUILD_DOCUMENTATION})
 
-set(LIBRARY_TYPE, "")
-if (MAILIO_BUILD_SHARED_LIBRARY)
-    set(LIBRARY_TYPE "SHARED")
-else()
-    set(LIBRARY_TYPE "STATIC")
-endif()
-add_library(${PROJECT_NAME} ${LIBRARY_TYPE} ${project_sources} ${project_headers})
+add_library(${PROJECT_NAME} ${project_sources} ${project_headers})
 
 
 # pkg-config support

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+find_package(Boost REQUIRED COMPONENTS unit_test_framework)
 
 function(add_mailio_tests SOURCE_FILE)
     get_filename_component(file_name ${SOURCE_FILE} NAME_WE)

=== debian/changelog ===
mailio (0.23.0+git20241012.8821f91-1) unstable; urgency=medium

  * New upstream release.

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 13 Oct 2024 22:03:29 +0200

=== debian/control ===
Source: mailio
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
	, cmake
	, libboost-date-time-dev
	, libboost-regex-dev
	, libboost-system-dev
	, libboost-test-dev
	, libssl-dev
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/karastojko/mailio
Vcs-Browser: https://salsa.debian.org/alteholz/mailio
Vcs-Git: https://salsa.debian.org/alteholz/mailio.git
Rules-Requires-Root: no

Package: mailio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmailio1 (= ${binary:Version}), ${misc:Depends}
Description: cross platform C++ library for email support (development)
 mailio is a cross platform C++ library for MIME format and SMTP, POP3
 and IMAP protocols.
 .
 It is based on the standard C++ 17 and Boost library.
 .
 This package contains the development files.

Package: libmailio1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: cross platform C++ library for email support (library)
 mailio is a cross platform C++ library for MIME format and SMTP, POP3
 and IMAP protocols.
 .
 It is based on the standard C++ 17 and Boost library.
 .
 This package contains the library.

## mailio 0.25.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.16.3)
 
-project(mailio VERSION 0.24.0)
+project(mailio VERSION 0.25.3)
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
@@ -113,16 +113,13 @@
         set(DOXYGEN_OUTPUT_PATH ${DOCOUTDIR})
 
         doxygen_add_docs(docs ${PROJECT_SOURCE_DIR}/include ALL WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
-
-        # install the documentation
-        install(DIRECTORY ${DOXYGEN_OUTPUT_DIRECTORY} DESTINATION docs)
     else(DOXYGEN_FOUND)
         message(STATUS "doxygen was not found, documentation will not be built")
     endif(DOXYGEN_FOUND)
 endif(${MAILIO_BUILD_DOCUMENTATION})
 
 add_library(${PROJECT_NAME} ${project_sources} ${project_headers})
-
+add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
 
 # pkg-config support
 set(prefix "${CMAKE_INSTALL_PREFIX}")
@@ -179,16 +176,47 @@
 
 install(DIRECTORY include/mailio DESTINATION ${INCLUDE_INSTALL_DIR})
 
+include(CMakePackageConfigHelpers)
+include(GNUInstallDirs)
+
+# Target
 install(TARGETS ${PROJECT_NAME}
-    EXPORT ${PROJECT_NAME}Config
-    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
-    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
-    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
-)
-
-export(TARGETS ${PROJECT_NAME} FILE ${PROJECT_NAME}Config.cmake)
-
-install(EXPORT ${PROJECT_NAME}Config DESTINATION share/${PROJECT_NAME}/cmake)
+    EXPORT ${PROJECT_NAME}-export
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
+)
+
+export(
+    EXPORT ${PROJECT_NAME}-export
+    NAMESPACE ${PROJECT_NAME}::
+    FILE ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-targets.cmake
+)
+
+install(EXPORT ${PROJECT_NAME}-export
+    NAMESPACE ${PROJECT_NAME}::
+    FILE ${PROJECT_NAME}-targets.cmake
+    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}/
+)
+
+# Config and version
+configure_package_config_file(
+    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/${PROJECT_NAME}-config.cmake.in
+    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
+    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}/
+)
+
+write_basic_package_version_file(
+    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+    VERSION ${PROJECT_VERSION}
+    COMPATIBILITY AnyNewerVersion
+)
+
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
+    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
+)
 
 # optionally build examples
 if(${MAILIO_BUILD_EXAMPLES})
@@ -198,6 +226,7 @@
 endif(${MAILIO_BUILD_EXAMPLES})
 
 if(${MAILIO_BUILD_TESTS})
+    enable_testing()
     add_subdirectory(test)
     file(GLOB PNGS "${PROJECT_SOURCE_DIR}/test/aleph0.png")
     install(FILES ${PNGS} DESTINATION "${SHARE_INSTALL_DIR}/${PROJECT_NAME}/test/")

=== examples/CMakeLists.txt ===
# "inline" function to add mailio sources easily.
function(add_mailio_example SOURCE_FILE)
    get_filename_component(file_name ${SOURCE_FILE} NAME_WE)
    add_executable(${file_name} ${SOURCE_FILE})
    target_link_libraries(${file_name} PUBLIC mailio ${CMAKE_THREAD_LIBS_INIT})
    install(TARGETS ${file_name} DESTINATION "${SHARE_INSTALL_DIR}/${PROJECT_NAME}/examples")
endfunction(add_mailio_example)

# find all the example files.
file(GLOB example_files ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp)

# loop through each file and add the example
foreach(file_name ${example_files})
    add_mailio_example(${file_name})
endforeach(file_name ${example_files})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,11 @@
 function(add_mailio_tests SOURCE_FILE)
     get_filename_component(file_name ${SOURCE_FILE} NAME_WE)
     add_executable(${file_name} ${SOURCE_FILE})
-    if (${MAILIO_DYN_LINK_TESTS})
-	    add_definitions(-DBOOST_TEST_DYN_LINK)
+    add_test(NAME ${file_name} COMMAND ${file_name})
+    include("CTest")
+    set_tests_properties(${file_name} PROPERTIES WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test")
+    if(${MAILIO_DYN_LINK_TESTS})
+        add_definitions(-DBOOST_TEST_DYN_LINK)
     endif()
     target_link_directories(${file_name} PUBLIC ${Boost_LIBRARY_DIRS})
     target_link_libraries(${file_name} PUBLIC ${Boost_LIBRARIES} mailio ${CMAKE_THREAD_LIBS_INIT})

=== debian/changelog ===
mailio (0.25.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: bump standard to 4.7.2 (no changes)
  * bump soname to 2

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 17 Aug 2025 10:00:47 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	, libboost-system-dev
 	, libboost-test-dev
 	, libssl-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/karastojko/mailio
 Vcs-Browser: https://salsa.debian.org/alteholz/mailio
@@ -19,7 +19,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmailio1 (= ${binary:Version}), ${misc:Depends}
+Depends: libmailio2 (= ${binary:Version}), ${misc:Depends}
 Description: cross platform C++ library for email support (development)
  mailio is a cross platform C++ library for MIME format and SMTP, POP3
  and IMAP protocols.
@@ -28,7 +28,7 @@
  .
  This package contains the development files.
 
-Package: libmailio1
+Package: libmailio2
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,10 @@
 %:
 	dh $@
 
+override_dh_install:
+	find
+	dh_install
+
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DMAILIO_BUILD_SHARED_LIBRARY=ON

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libahp-gt-$1\.tar\.gz/ \
  https://github.com/karastojko/mailio/tags .*/v?(\d\S+)\.tar\.gz \
  debian uupdate
